#include "StdAfx.h"
#include "EnemyAi.h"

EnemyAi::EnemyAi()
{
}

EnemyAi::EnemyAi(int i)
{
	this->play_id = i;	//	player_id
	
}


EnemyAi::~EnemyAi(void)
{
}

//-----------------------------------
//	]_
//-----------------------------------
int EnemyAi::ai_000_calc(Player *pl)
{
const int toitsu_tb[10][2] = {
	{ 0, 0     },// 0
	{ 1, AI_20 },// 11
	{ 2, AI_20 },// 22
	{ 3, AI_20 },// 33 
	{ 4, AI_20 },// 44
	{ 5, AI_20 },// 55
	{ 6, AI_20 },// 66
	{ 7, AI_20 },// 77
	{ 8, AI_20 },// 88
	{ 9, AI_20 },// 99
};

const int kotsu_tb[10][2] = {
	{ 0, 0     },// 0
	{ 1, AI_60 },// 11
	{ 2, AI_60 },// 22
	{ 3, AI_60 },// 33 
	{ 4, AI_60 },// 44
	{ 5, AI_60 },// 55
	{ 6, AI_60 },// 66
	{ 7, AI_60 },// 77
	{ 8, AI_60 },// 88
	{ 9, AI_60 },// 99
};

const int syuntsu_tb[8][2] = {
	{ 0, 0     },	// 0
	{ 1, AI_60 },	// 123
	{ 2, AI_60 },	// 234
	{ 3, AI_60 },	// 345 
	{ 4, AI_60 },	// 456
	{ 5, AI_60 },	// 567
	{ 6, AI_60 },	// 678
	{ 7, AI_60 },	// 789
};

const int kan_tatsu_tb[8][2] = {
	{ 0, 0     },	// 0
	{ 1, AI_10 },	// 1-3
	{ 2, AI_20 },	// 2-4
	{ 3, AI_20 },	// 3-5
	{ 4, AI_20 },	// 4-6
	{ 5, AI_20 },	// 5-7
	{ 6, AI_20 },	// 6-8
	{ 7, AI_10 },	// 7-9
};

const int ryan_tatsu_tb[9][2] = {
	{ 0, 0     },	// 0
	{ 1, AI_10 },	// 12-
	{ 2, AI_20 },	// 23
	{ 3, AI_20 },	// 34
	{ 4, AI_20 },	// 45
	{ 5, AI_20 },	// 56
	{ 6, AI_20 },	// 67
	{ 7, AI_20 },	// 78
	{ 8, AI_10 },	// 89-
};

	for(int i=0; i<pl->cal_count; i++ )
	{
		MEN_TSU_WORK *calc_p = &pl->calc_buff[i];

		for( int t=0; t < calc_p->men_count; t++ )
		{
			switch(calc_p->kind_t[t])
			{
			case MEN_NULL:		//	NULL
				break;
			case MEN_TOI_TSU:	//	ΎqigCcj
				calc_p->kind_p[t] =  toitsu_tb[calc_p->mentsu[t] & HAI_NUMB_MSK][1];
				break;
			case MEN_KOU_TSU:	//	qiR[cj
			case MEN_KAN_TSU:	//	ȎqiJcj
				calc_p->kind_p[t] =  kotsu_tb[calc_p->mentsu[t] & HAI_NUMB_MSK][1];
				break;
			case MEN_SHUN_TSU:	//	qiVcEWcj
				calc_p->kind_p[t] =  syuntsu_tb[calc_p->mentsu[t] & HAI_NUMB_MSK][1];
				break;
			case MEN_RYAN_TATSU://	ʓqi^[cj
			case MEN_PEN_TATSU:	//	ӓqiy^[cj			
				calc_p->kind_p[t] =  ryan_tatsu_tb[calc_p->mentsu[t] & HAI_NUMB_MSK][1];
				break;
			case MEN_KAN_TATSU:	//	ƓqiJ^[cj
				calc_p->kind_p[t] =  kan_tatsu_tb[calc_p->mentsu[t] & HAI_NUMB_MSK][1];
				break;
			}
		}
	}

return TRUE;	// ĂȂĂAobt@[ɋL^I(`h)
}
//------------------------------------
//	Rs[]I
//------------------------------------
int EnemyAi::ai_001_calc(Player *pl)
{
MEN_TSU_WORK *calc_p;
MEN_AI_WORK  *comp_p;

	SecureZeroMemory( this->ai_buff, sizeof(this->ai_buff));

	for(int i=0; i<pl->cal_count; i++ )
	{
		calc_p = &pl->calc_buff[i];
		comp_p = &this->ai_buff[i];
		comp_p->total_p = 0;

		int men_pnt = 1000;	//	ʎqŕꍇI
		int men_idx = -1;	//	-1 = error ؂vȂI

		//	ʎq̍v_vZ@@Œ̖ʎqII
		for( int i=0; i < calc_p->men_count; i++ )
		{
			comp_p->kind_p[i] = calc_p->kind_p[i];	// copy !
			comp_p->total_p  += calc_p->kind_p[i];	// total ! 

			if( comp_p->kind_p[i] < men_pnt ) {		//	ԒႢʎq̓_I
				men_pnt = comp_p->kind_p[i];
				men_idx = i;
			}
		}
		comp_p->men_cut_idx = men_idx;	//	ꍇ̖ʎqiindex)
		comp_p->men_cut_pnt = men_pnt;	//	ꍇ̖ʎqi_)

		if( calc_p->hai_count ) {
		//	]vRs[
			for( int i=0; i < calc_p->hai_count; i++ ) {
				comp_p->am_numb[i] = calc_p->numb[i];	// ]vI
			}
			comp_p->am_hai_count = calc_p->hai_count;

		} else {
		//	]vȂꍇ́AI
			comp_p->am_numb[0]	 = calc_p->mentsu[comp_p->men_cut_idx];
			comp_p->am_numb[1]	 = calc_p->men_2d[comp_p->men_cut_idx];
			comp_p->am_hai_count = 2;
		}
	}



	//	ԍʎq̍v_vZ
	int max_pnt = 0;	//	
	int max_idx = -1;	//	-1 = error ؂vȂI

		for( int i=0; i < calc_p->men_count; i++ )
		{
			if( comp_p->total_p > max_pnt ) {
				max_pnt = comp_p->total_p;
				max_idx = i;
			}
		}
		this->ai_sel_pnt = max_idx;		//	Iindex

return TRUE;
}

////------------------------------------
////	܂肪OȂAI
////------------------------------------
//int EnemyAi::ai_cut_calc(Player *pl)
//{
//MEN_AI_WORK  *comp_p;
//
////
////	v_̂ɁA؂nCȂI
////
//	comp_p = &this->ai_buff[this->ai_sel_pnt];
//	if( comp_p->am_hai_count ) {
//		return TRUE;
//	}
//return TRUE;
//}

//------------------------------------
//
//------------------------------------
int EnemyAi::ai_003_calc(Player *pl)
{
MEN_AI_WORK  *comp_p;
int numb = 0;

	comp_p = &this->ai_buff[this->ai_sel_pnt];
	numb = comp_p->am_cut_numb;

return numb;
}

//------------------------------------
//	܂v̕]îQj
//------------------------------------
int EnemyAi::ai_one_calc(Player *pl,MEN_TSU_WORK *calc_p, int numb)
{
int point = 0;
int n1;
int n2;

const int TOISU_TB_SIZE = 5;
const int SYUNTSU_TB_SIZE = 7;
const int KAN_TATSU_TB_SIZE = 7;
const int RYAN_TATSU_TB_SIZE = 6;


const int toitsu_tb[10][TOISU_TB_SIZE][2] = {
	{{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     }},	// 0
	{{ 1, AI_20 },{ 0, 0     },{ 2, AI_10 },{ 0, 0     },{ 3, AI_05 }},	// 1(-2)(-3)
	{{ 2, AI_20 },{ 1, AI_10 },{ 3, AI_10 },{ 0, 0     },{ 4, AI_05 }}, // 2(13)(-4)
	{{ 3, AI_20 },{ 2, AI_10 },{ 4, AI_10 },{ 1, AI_05 },{ 5, AI_05 }},	// 3(24)(15) 
	{{ 4, AI_20 },{ 3, AI_10 },{ 5, AI_10 },{ 2, AI_05 },{ 6, AI_05 }},	// 4(35)(26)
	{{ 5, AI_20 },{ 4, AI_10 },{ 6, AI_10 },{ 3, AI_05 },{ 7, AI_05 }},	// 5(46)(37)
	{{ 6, AI_20 },{ 5, AI_10 },{ 7, AI_10 },{ 4, AI_05 },{ 8, AI_05 }},	// 6(57)(48)
	{{ 7, AI_20 },{ 6, AI_10 },{ 8, AI_10 },{ 5, AI_05 },{ 9, AI_05 }},	// 7(68)(59)
	{{ 8, AI_20 },{ 7, AI_10 },{ 9, AI_10 },{ 6, AI_05 },{ 0, 0     }}, // 8(79)(6-)
	{{ 9, AI_20 },{ 8, AI_10 },{ 0, 0     },{ 7, AI_05 },{ 0, 0     }},	// 9(8-)(7-)
};

const int syuntsu_tb[8][SYUNTSU_TB_SIZE][2] = {
	{{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     }},	// 0
	{{ 1, AI_10 },{ 2, AI_05 },{ 3, AI_10 },{ 0, 0     },{ 4, AI_10 },{ 0, 0     },{ 5, AI_10 }},	// 123(-4)(-5)
	{{ 2, AI_10 },{ 3, AI_05 },{ 4, AI_10 },{ 1, AI_10 },{ 5, AI_10 },{ 0, 0     },{ 6, AI_10 }},	// 234(15)(-6)
	{{ 3, AI_10 },{ 4, AI_05 },{ 5, AI_10 },{ 2, AI_10 },{ 6, AI_10 },{ 1, AI_10 },{ 7, AI_10 }},	// 345(26)(17) 
	{{ 4, AI_10 },{ 5, AI_05 },{ 6, AI_10 },{ 3, AI_10 },{ 7, AI_10 },{ 2, AI_10 },{ 8, AI_10 }},	// 456(37)(28)
	{{ 5, AI_10 },{ 6, AI_05 },{ 7, AI_10 },{ 4, AI_10 },{ 8, AI_10 },{ 3, AI_10 },{ 9, AI_10 }},	// 567(48)(39)
	{{ 6, AI_10 },{ 7, AI_05 },{ 8, AI_10 },{ 5, AI_10 },{ 9, AI_10 },{ 4, AI_10 },{ 0, 0     }},	// 678(59)(4-)
	{{ 7, AI_10 },{ 8, AI_05 },{ 9, AI_10 },{ 6, AI_10 },{ 0, 0     },{ 5, AI_10 },{ 0, 0     }},	// 789(6-)(5-)
};

const int kan_tatsu_tb[8][KAN_TATSU_TB_SIZE][2] = {
	{{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     }},	// 0
	{{ 1, AI_20 },{ 2, AI_20 },{ 3, AI_20 },{ 0, 0     },{ 4, AI_10 },{ 0, 0     },{ 5, AI_10 }},	// 123(-4)(-5)
	{{ 2, AI_20 },{ 3, AI_20 },{ 4, AI_20 },{ 1, AI_10 },{ 5, AI_10 },{ 0, 0     },{ 6, AI_10 }},	// 234(15)(-6)
	{{ 3, AI_20 },{ 4, AI_20 },{ 5, AI_20 },{ 2, AI_10 },{ 6, AI_10 },{ 1, AI_10 },{ 7, AI_10 }},	// 345(26)(17) 
	{{ 4, AI_20 },{ 5, AI_20 },{ 6, AI_20 },{ 3, AI_10 },{ 7, AI_10 },{ 2, AI_10 },{ 8, AI_10 }},	// 456(37)(28)
	{{ 5, AI_20 },{ 6, AI_20 },{ 7, AI_20 },{ 4, AI_10 },{ 8, AI_10 },{ 3, AI_10 },{ 9, AI_10 }},	// 567(48)(39)
	{{ 6, AI_20 },{ 7, AI_20 },{ 8, AI_20 },{ 5, AI_10 },{ 9, AI_10 },{ 4, AI_10 },{ 0, 0     }},	// 678(59)(4-)
	{{ 7, AI_20 },{ 8, AI_20 },{ 9, AI_20 },{ 6, AI_10 },{ 0, 0     },{ 5, AI_10 },{ 0, 0     }},	// 789(6-)(5-)
};

const int ryan_tatsu_tb[9][RYAN_TATSU_TB_SIZE][2] = {
	{{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     },{ 0, 0     }},	// 0
	{{ 1, AI_20 },{ 2, AI_20 },{ 0, 0     },{ 3, AI_10 },{ 0, 0     },{ 4, AI_05 }},	// 12(-3)(-4)
	{{ 2, AI_20 },{ 3, AI_20 },{ 1, AI_10 },{ 4, AI_10 },{ 0, 0     },{ 5, AI_05 }},	// 23(14)(-5)
	{{ 3, AI_20 },{ 4, AI_20 },{ 2, AI_10 },{ 5, AI_10 },{ 1, AI_05 },{ 6, AI_05 }},	// 34(25)(16) 
	{{ 4, AI_20 },{ 5, AI_20 },{ 3, AI_10 },{ 6, AI_10 },{ 2, AI_05 },{ 7, AI_05 }},	// 45(36)(27)
	{{ 5, AI_20 },{ 6, AI_20 },{ 4, AI_10 },{ 7, AI_10 },{ 3, AI_05 },{ 8, AI_05 }},	// 56(47)(38)
	{{ 6, AI_20 },{ 7, AI_20 },{ 5, AI_10 },{ 8, AI_10 },{ 4, AI_05 },{ 9, AI_05 }},	// 67(58)(49)
	{{ 7, AI_20 },{ 8, AI_20 },{ 6, AI_10 },{ 9, AI_10 },{ 5, AI_05 },{ 0, 0     }},	// 78(69)(5-)
	{{ 8, AI_20 },{ 9, AI_20 },{ 7, AI_10 },{ 0, 0     },{ 6, AI_05 },{ 0, 0     }},	// 89(7-)(6-)
};

		// v́A
		if( numb & HAI_KIND_JIH ) {
			return point;
		}

		for( int i=0; i < calc_p->men_count; i++ )
		{
			if( calc_p->naki_f[i] == CAL_NAKI_F) { continue; }	//	ʑOH
	
			switch( calc_p->kind_t[i] )		//	ʎqiΎq,q,q,Ȏqj
			{

			//-----------------------
			//	ΎqigCcj
			//	qiR[cj
			//	ȎqiJcj
			//-----------------------
			case MEN_KOU_TSU:
			case MEN_KAN_TSU:
			case MEN_TOI_TSU:

				n1 = calc_p->mentsu[i]; n2 = numb;
				if((n1 & HAI_KIND_MSK) != (n2 & HAI_KIND_MSK)) { break; }
				n1 = calc_p->mentsu[i] & HAI_NUMB_MSK;
				n2 = numb & HAI_NUMB_MSK;

				for(int t=0;t<TOISU_TB_SIZE;t++) {
					if( toitsu_tb[n1][t][0] == n2 ) {
						point += toitsu_tb[n1][t][1];
						break;
					}
				}
				break;

			//-----------------------
			//	qiVcEWcj
			//-----------------------
			case MEN_SHUN_TSU:

				n1 = calc_p->mentsu[i]; n2 = numb;
				if((n1 & HAI_KIND_MSK) != (n2 & HAI_KIND_MSK)) { break; }
				n1 = calc_p->mentsu[i] & HAI_NUMB_MSK;
				n2 = numb & HAI_NUMB_MSK;

				for(int t=0;t<SYUNTSU_TB_SIZE;t++) {
					if( syuntsu_tb[n1][t][0] == n2 ) {
						point += syuntsu_tb[n1][t][1];
						break;
					}
				}
				break;

			//-----------------------
			//	ƓqiJ^[cj
			//-----------------------
			case MEN_KAN_TATSU:

				n1 = calc_p->mentsu[i]; n2 = numb;
				if((n1 & HAI_KIND_MSK) != (n2 & HAI_KIND_MSK)) { break; }
				n1 = calc_p->mentsu[i] & HAI_NUMB_MSK;
				n2 = numb & HAI_NUMB_MSK;

				for(int t=0;t<KAN_TATSU_TB_SIZE;t++) {
					if( kan_tatsu_tb[n1][t][0] == n2 ) {
						point += kan_tatsu_tb[n1][t][1];
						break;
					}
				}
				break;

			//-----------------------
			//	ʓqi^[cj
			//	ӓqiy^[cj
			//-----------------------
			case MEN_RYAN_TATSU:
			case MEN_PEN_TATSU:
				n1 = calc_p->mentsu[i]; n2 = numb;
				if((n1 & HAI_KIND_MSK) != (n2 & HAI_KIND_MSK)) { break; }
				n1 = calc_p->mentsu[i] & HAI_NUMB_MSK;
				n2 = numb & HAI_NUMB_MSK;

				for(int t=0;t<RYAN_TATSU_TB_SIZE;t++) {
					if( ryan_tatsu_tb[n1][t][0] == n2 ) {
						point += ryan_tatsu_tb[n1][t][1];
						break;
					}
				}
				break;
			}
		}

return point;
}
//------------------------------------
//	܂v̕]
//------------------------------------
int EnemyAi::ai_002_calc(Player *pl)
{
MEN_AI_WORK  *comp_p;
MEN_TSU_WORK *calc_p;

int numb_point[10] = {
	0,	//	0
	0,	//	1
	2,	//	2
	3,	//	3
	4,	//	4
	5,	//	5
	4,	//	6
	3,	//	7
	2,	//	8
	0,	//	9
};

//
//
//
	for(int i=0; i<pl->cal_count; i++ )
	{
		comp_p = &this->ai_buff[i];
		calc_p = &pl->calc_buff[i];

		for( int i=0; i < comp_p->am_hai_count; i++ )
		{
			int ji_pnt = 0;
			int dr_pnt = 0;
			int mn_pnt = 0;
			int nx_pnt = 0;
			int am_numb = comp_p->am_numb[i];

			if( am_numb & HAI_KIND_JIH ) {
				// vȂEEE
				ji_pnt = hai_check::hai_ba_kaze_check(pl, am_numb) * 5;
			} else {
				//	̔vL
				mn_pnt = numb_point[ am_numb & HAI_NUMB_MSK ];
			}

			// hEEE
			dr_pnt = ai_dora_calc(pl, am_numb) * 5;
			//	ꖇƁAʎqȂĂ邩H
			nx_pnt = ai_one_calc(pl, calc_p, am_numb);	

			comp_p->am_point[i] = (ji_pnt + dr_pnt + mn_pnt + nx_pnt);
		}
//
//	̂ĂvIԁI
//
		int min_pnt = 1000;	//	
		int min_idx = -1;	//	-1 = error ؂vȂI

		for( int i=0; i < comp_p->am_hai_count; i++ )
		{
			if( comp_p->am_point[i] < min_pnt ) {
				min_pnt = comp_p->am_point[i];
				min_idx = i;
			}
		}
			comp_p->am_cut_pnt  = min_idx;					//	]v̐؂
			comp_p->am_cut_numb = comp_p->am_numb[min_idx];	//	]v̔ԍ
	}

return TRUE;
}

//------------------------------------
//	hȂ
//------------------------------------
int EnemyAi::ai_dora_calc(Player *pl, int ai_numb)
{
int cont = 0;
int ura_p = 0;

	for(int i=HAI_DORA_FST; i > hai_num_buff->dora_hai_pnt ;i-- )
	{
		int base = hai_num_buff->hai_rand_num[i].numb & HAI_SORT_MSK;	//	JR
		int numb = hai_check::get_dora_hai(base);						//	h

		if( ura_p++ % 2 ) {
			continue;		//	[`|ĂȂꍇ́A\ǂ̂݁B
		}

		if( numb == ai_numb ) { cont++; }	//	ʎq̐擪̔v
	}
return cont;
}

//------------------------------------
//	`hC
//	ÃJF
//	_F
//------------------------------------
int EnemyAi::tumo_calc(Player *pl)
{
int ai_numb = hai_null;

	if(pl->play_id != 1 ) {	// G͂Pԍ؂
		return pl->hai_buff[0].numb & HAI_SORT_MSK;
	}

	if( hai_calc::agari_sub(pl, hai_null, AGARI_TUMO, CHK_LV2 )){
		// ȂŁAcĂ܂ꍇEEE
		return pl->hai_buff[0].numb;
	}

	ai_000_calc(pl);			//
	ai_001_calc(pl);			//	data copy	//	ai_cut_calc(pl);			//	܂肪OȂA킴ƕI
	ai_002_calc(pl);			//	܂]
	ai_numb = ai_003_calc(pl);	//	I
	ai_dbg_print(pl);			//	fobO\

return ai_numb;
}

//------------------------------------
//	fobO\
//------------------------------------
int EnemyAi::ai_dbg_print(Player *pl)
{
MEN_TSU_WORK *calc_p;
MEN_AI_WORK  *comp_p;

#ifdef AI_DEBUG
stdx::dstream ds;
char msg[256];
char msg_info[1024];
char msg_hai[1024];
char msg_head[1024];
#endif
#ifdef AI_DEBUG

	ds << "---- vl-----" << std::endl;

	SecureZeroMemory( msg_head, sizeof(msg_head));
	sprintf_s( msg, sizeof(msg), "[P%d:=%d] ", pl->play_id, pl->toi_count );
	strcat_s( msg_head, 1024, msg ); 

	for(int i=0; i<pl->toi_count; i++ )
	{
		sprintf_s( msg, sizeof(msg), "[%s] ", 
			hai_img::idx_to_name(pl->toi_tsu[i]));
		strcat_s( msg_head, 1024, msg ); 
	}
	ds << msg_head << std::endl;

	for(int i=0; i<pl->cal_count; i++ )
	{
		SecureZeroMemory( msg_info, sizeof(msg_info));
		SecureZeroMemory( msg_hai, sizeof(msg_hai));

		calc_p = &pl->calc_buff[i];
		comp_p = &this->ai_buff[i];
	
			sprintf_s( msg, sizeof(msg), "[P%d:No=%d] [c:%2d:v:%3d] %s", 
				pl->play_id, i, 
				calc_p->hai_count,
				comp_p->total_p,
				((this->ai_sel_pnt==i) ?"*" :" "));
			strcat_s( msg_info, 1024, msg ); 

			for( int i=0; i < calc_p->men_count; i++ )
			{
				sprintf_s( msg, sizeof(msg), "[%02d:%s:%s] ",
					calc_p->kind_p[i],
					hai_calc::get_mentsu_name(calc_p->kind_t[i]),
					hai_img::idx_to_name(calc_p->mentsu[i]));
				strcat_s( msg_info, 1024, msg ); 
			}

			for( int i=0; i < comp_p->am_hai_count; i++ )
			{
				sprintf_s( msg, sizeof(msg), "[%s%2d:%s] ",
					((comp_p->am_cut_numb==comp_p->am_numb[i]) ?"*" :" "),
					comp_p->am_point[i],
					hai_img::idx_to_name(comp_p->am_numb[i]));
				strcat_s( msg_hai, 1024, msg ); 
			}

		ds << msg_info << std::endl;
		ds << msg_hai  << std::endl;
	}
#endif

	return TRUE;
}

