#include "StdAfx.h"

hai_img::hai_img( int img_index )
{
char f_name[FILE_NAME_SIZE];

	this->img_index = img_index;
	this->width = hai_size[img_index][0];
	this->height= hai_size[img_index][1];
	strcpy_s( this->file_name, sizeof(this->file_name), &hai_img::hai_file[this->img_index][0]); 	
	sprintf_s( f_name, FILE_NAME_SIZE, "..\\hai\\%s", this->file_name );

	this->hBitmap = (HBITMAP)LoadImage(
					(HINSTANCE)GetWindowLong(hWnd , GWL_HINSTANCE) ,
					f_name , IMAGE_BITMAP ,
					0 , 0 , LR_LOADFROMFILE );

	this->hMemDC = CreateCompatibleDC(hai_img::hHDC);
	SelectObject( this->hMemDC, this->hBitmap);
	GetObject( this->hBitmap , sizeof(BITMAP) , &this->bitmap );	// hBitmap HeaderAbitmap ɐݒ
}

hai_img::~hai_img(void)
{
	DeleteDC(this->hMemDC);
	DeleteObject(this->hBitmap);
}

//
//	v摜index֕ϊB
//
int hai_img::num_to_img(int number, int ura)
{
	if((number & HAI_SORT_MSK) == HAI_EOFH ) {
		return hai_null;
	}

	if(ura) {
		return hai_ura;
	}

	int n = (number & HAI_NUMB_MSK);
	int k = (number & HAI_KIND_MSK) >> 9;

	if ( number & HAI_RED_FLG ) {
		if ( n == 5 ) { // ԂT}ATsAT
			return kind_to_red[ k ];
		}
	}
return n + kind_to_idx[ k ];
}

//
//	vindexAv̖O
//
const char* hai_img::idx_to_name(int number)
{
	return &hai_name_tb[num_to_img(number,0)][0];
}

void hai_img::Hai_hWnd_Set(HWND hWnd)
{
HDC	hdc	= GetDC(hWnd);
	hai_img::hWnd = hWnd;	
	hai_img::hHDC = CreateCompatibleDC(hdc);
}

//
//	ÓIϐ̏
//
HWND hai_img::hWnd = NULL;
HDC	 hai_img::hHDC = NULL;

//
//	ÓIϐe[u
//
const int hai_img::kind_to_idx[5] = {
	9*0,	//	0	}Y
	9*1,	//	1	s
	9*2,	//	2	
	0,		//	x
	9*3,	//	4	v
};

const int hai_img::kind_to_red[5] = {
	hai_man5red,
	hai_pin5red,
	hai_sou5red,
	0,		//	x
	0,		//	4	v
};

const char hai_img::hai_file[HAI_IMG_COUNT][HAI_NAME_SIZE] = {
	{"x_hai_all_bn.bmp"},	//	c p1
	{"y_hai_all_bn.bmp"},	//	剡 p2
	{"x_hai_all_br.bmp"},	//	c p3i摜]ς݁j
	{"y_hai_all_br.bmp"},	//	剡 p4i摜]ς݁j
	{"x_hai_all_mn.bmp"},	//	c p1
	{"y_hai_all_mn.bmp"},	//	 p2
	{"x_hai_all_mr.bmp"},	//	c p3i摜]ς݁j
	{"y_hai_all_mr.bmp"},	//	 p4i摜]ς݁j
	{"hbous.bmp"},			//	100__
	{"sbous.bmp"},			//	1000__
	{"gbous.bmp"},			//	5000__
	{"mbous.bmp"},			//	10000__
};

const int hai_img::hai_size[HAI_IMG_COUNT][2] = {
	{ HAI_SIZE_TATE_BX,	HAI_SIZE_TATE_BY	},
	{ HAI_SIZE_YOKO_BX,	HAI_SIZE_YOKO_BY	},
	{ HAI_SIZE_TATE_BX,	HAI_SIZE_TATE_BY	},
	{ HAI_SIZE_YOKO_BX,	HAI_SIZE_YOKO_BY	},
	{ HAI_SIZE_TATE_MX,	HAI_SIZE_TATE_MY	},
	{ HAI_SIZE_YOKO_MX,	HAI_SIZE_YOKO_MY	},
	{ HAI_SIZE_TATE_MX,	HAI_SIZE_TATE_MY	},
	{ HAI_SIZE_YOKO_MX,	HAI_SIZE_YOKO_MY	},
	{ 110,				11	},
	{ 110,				11	},
	{ 110,				11	},
	{ 110,				11	},
};


const int hai_img::int_tb[HAI_COUNT+1] = {
	hai_null,
	man_ace,
	man_two,
	man_three,
	man_four,
	man_five,
	man_six,
	man_seven,
	man_eight,
	man_nine,

	pin_ace,
	pin_two,
	pin_three,
	pin_four,
	pin_five,
	pin_six,
	pin_seven,
	pin_eight,
	pin_nine,

	sou_ace,
	sou_two,
	sou_three,
	sou_four,
	sou_five,
	sou_six,
	sou_seven,
	sou_eight,
	sou_nine,

	hai_ton,
	hai_nan,
	hai_sha,
	hai_pei,
	hai_haku,
	hai_hatu,
	hai_tyun,

	hai_man5red,
	hai_pin5red,
	hai_sou5red,
	hai_ura
};	// 9*3+7+4=38


const char hai_img::hai_name_tb[HAI_COUNT+1][HAI_NAME_SIZE] = {
	{ "NULL@" }, // hai_null,
	{ "P@" }, // 	man_ace,
	{ "Q@" }, // 	man_two,
	{ "R@" }, // 	man_three,
	{ "S@" }, // 	man_four,
	{ "T@" }, // 	man_five,
	{ "U@" }, // 	man_six,
	{ "V@" }, // 	man_seven,
	{ "W@" }, // 	man_eight,
	{ "X@" }, // 	man_nine,

	{ "Ps" }, // 	pin_ace,
	{ "Qs" }, //	pin_two,
	{ "Rs" }, //	pin_three,
	{ "Ss" }, //	pin_four,
	{ "Ts" }, //	pin_five,
	{ "Us" }, //	pin_six,
	{ "Vs" }, //	pin_seven,
	{ "Ws" }, //	pin_eight,
	{ "Xs" }, //	pin_nine,

	{ "P\E" }, //	sou_ace,
	{ "Q\E" }, //	sou_two,
	{ "R\E" }, //	sou_three,
	{ "S\E" }, //	sou_four,
	{ "T\E" }, //	sou_five,
	{ "U\E" }, //	sou_six,
	{ "V\E" }, //	sou_seven,
	{ "W\E" }, //	sou_eight,
	{ "X\E" }, //	sou_nine,

	{ "@@" }, //	hai_ton,
	{ "@@" }, //	hai_nan,
	{ "@@" }, //	hai_sha,
	{ "k@@" }, //	hai_pei,
	{ "@@" }, //	hai_haku,
	{ "@@" }, //	hai_hatu,
	{ "@@" }, //	hai_tyun,

	{ "ԂT" },	//hai_man5red,
	{ "ԂTs" },	//hai_pin5red,
	{ "ԂT\" },	//hai_sou5red,
	{ "@" },	//hai_ura
};	// 9*3+7+4=38


const char hai_img::yaku_name_tb[IDX_LAST_YAKU+1][YAKUI_NAME_SIZE] = {
	{ " or _u        "},		//0
	{ "ꔭiCbpcj          "},		//1
	{ "O̘a(c)        "},		//2
	{ "a(st)              "},		//3
	{ "fI(^I)        "},		//4
	{ "u(C[y[R)        "},		//5
	{ "viNnCj          "},		//6
	{ "JԁiVJCzEj"},	//7
	{ "ȁi`Jj        "},		//8
	{ "ČinCeCcj  "},		//9
	{ "͒ꝝinCeCj  "},		//10
	{ "OF^TVNhEW"},	//11
	{ "Cʊс^CbLcEJ  "},		//12
	{ "Sы^z`^CI"},		//13
	{ "Ύq^`[gCc        "},		//14
	{ "΁Xa^gCgCz[      "},		//15
	{ "OÍ^TAR[      "},		//16
	{ "V^zEg[      "},		//17
	{ "OF^TVNh[R["},		//18
	{ "OȎq^TJc        "},		//19
//
	{ "O^VETQ    "},		//20
	{ "Av^tHpC    "},		//21
	{ "F^zCc          "},		//22
	{ "SуI^W`"},		//23
	{ "u^y[R      "},		//24
	{ "F^`C[\        "},		//25
	{ "mo^RNV\E    "},		//26
	{ "lÍ^X[AR[      "},		//27
	{ "O^_CTQ      "},		//28
	{ "F^c[C[\[      "},		//29
	{ "l^VEX[V[    "},		//30
	{ "l^_CX[V[      "},		//31
	{ "ΈF^[C[\[    "},		//32
	{ "V^`[g[      "},		//33
	{ "lȎq^X[Jc        "},		//34
	{ "@󓕁^`[|E  "},	//35
	{ "Va^ezE            "},	//36
	{ "na^`[zE            "},	//37
//  [ҏW]
	{ "с^Ȃ܂񂪂  "},	//38
//	[J
	{ "OA^TR[      "},	//39
	{ "lA^X[R[      "},	//41
	{ "ԗց^      "},	//42
	{ "A^p[`    "},	//43
	{ "h                      "},	//44
	{ "te^`{        "},	//45
	{ "H^̂ݖ^`{"},	//46
	{ "Ȃ^`{          "},	//47
	{ "gp"},						//48
};
